<template>
  <div class="page page-itinerary">
    <div class="c-row items-start">
      <div class="c-col">
        <calendar
          v-model:selected-dates="selectedDates"
          v-model:roster-month="rosterMonth"
        />
        <q-card class="mt-30px">
          <q-card-section>
            <div class="text-item">
              <div class="text-12px">
                當月天數
              </div>
              <q-space />
              <div class="text-12px">
                {{ monthDays }}
              </div>
            </div>
            <div class="text-item">
              <div class="text-12px">
                未排定天數
              </div>
              <q-space />
              <div class="text-12px">
                {{ unscheduledDays }}
              </div>
            </div>
            <div class="text-item">
              <div class="text-12px">
                已排定天數
              </div>
              <q-space />
              <div class="text-12px">
                {{ scheduledDays }}
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
      <workbench
        v-model:vacancies="vacancies"
        class="h-full ml-30px"
        :selected-dates="selectedDates"
      />
      <q-card class="ml-30px w-300px">
        <q-card-section
          v-if="vacancies.length === 0"
          class="min-h-200px"
        >
          <div class="text-16px text-grey">
            請新增職缺
          </div>
        </q-card-section>
        <q-card-section
          v-else
          class="min-h-200px"
        >
          <div
            v-for="(value, key) in numberOfJobMap"
            :key="key"
            class="text-item my-5px"
          >
            <div class="text-12px">
              {{ key }}
            </div>
            <q-space />
            <div class="text-12px">
              {{ value }}
            </div>
          </div>
          <q-separator class="!my-10px" />
          <div
            v-for="(value, key) in numberOfJobTypeMap"
            :key="key"
            class="text-item my-5px"
          >
            <div class="text-12px">
              {{ key }}
            </div>
            <q-space />
            <div class="text-12px">
              {{ value }}
            </div>
          </div>
        </q-card-section>
        <q-card-actions>
          <q-btn
            unelevated
            :color="saveVacancyBtnColor"
            @click="saveVacancy"
          >
            儲存職缺
          </q-btn>
        </q-card-actions>
      </q-card>
    </div>
  </div>
</template>

<script lang='ts' setup>
import { computed, defineComponent, ref } from 'vue';
import dayjs from 'dayjs';
import { Vacancy, DayItinerary } from '../types/main.type';

import Calendar from '../views/page-itinerary/itinerary-calendar.vue';
import Workbench from '../views/page-itinerary/itinerary-workbench.vue';

import { useQuasar } from 'quasar';
import { useStatisticalData } from '../composables/use-statistical-data';
import { useMainStore } from '../store/main.store';

const $q = useQuasar();
const store = useMainStore();

const dayItineraries = computed(() => store.dayItineraries);

const rosterMonth = ref(dayjs().format('YYYY/MM'));

const selectedDates = ref([] as string[]);
const vacancies = ref([] as Vacancy[]);
const vacanciesError = computed(() => {
  const errors = vacancies.value.reduce((acc, vacancy, i) => {
    if (!vacancy.job) {
      acc.push(`第 ${i + 1} 個職缺之「工作」不可為空`);
      return acc;
    }

    if (!vacancy.jobType) {
      acc.push(`第 ${i + 1} 個職缺之「班別」不可為空`);
      return acc;
    }

    return acc;
  }, [] as string[]);

  return errors;
});
const saveVacancy = () => {
  if (vacanciesError.value.length !== 0) {
    $q.notify({
      type: 'negative',
      message: vacanciesError.value.join('</br>'),
      html: true,
    });
    return;
  }

  if (vacancies.value.length === 0) {
    $q.notify({
      type: 'negative',
      message: '請新增職缺',
    });
    return;
  }

  const dayItineraries = selectedDates.value.map((date) => {
    const dayItinerary: DayItinerary = {
      date,
      vacancies: vacancies.value,
    };

    return dayItinerary;
  });

  dayItineraries.forEach((dayItinerary) => {
    store.addDayItinerary(dayItinerary);
  });

  $q.notify({
    type: 'positive',
    message: `職缺儲存完成`,
  });
};

const {
  numberOfJobMap,
  numberOfJobTypeMap,
  monthDays,
  scheduledDays,
  unscheduledDays,
} = useStatisticalData({
  vacancies,
  rosterMonth,
  dayItineraries,
});

const saveVacancyBtnColor = computed(() => {
  if (vacanciesError.value.length !== 0) {
    return 'grey';
  }

  if (vacancies.value.length === 0) {
    return 'grey';
  }

  return 'primary';
});

</script>

<style scoped lang='sass'>

.page-itinerary
  width: 100%
  height: 100%
  display: flex
  flex-direction: column
  justify-content: center
  align-items: center
  .text-item
    display: flex
    &:not(:first-child)
      margin-top: 5px
</style>